#include <system.h>
#include <delay.h>

cycles_t currentcycles() 
{
    cycles_t result;
    __asm__ __volatile__ ("rdtsc" : "=A" (result));
    return result;
}

int cpu_speed()
{
	asm volatile ("cli");
	outportb(0x43,0x34);   // set PIT channel 0 to single-shot mode
	outportb(0x40,0);
	outportb(0x40,0);      // program the counter will be 0x10000 - n after n ticks
	long stsc=currentcycles();
	for (int i=0x1000;i>0;i--);
	long etsc=currentcycles();
	outportb(0x43,0x04);   // read PIT counter command ??
	byte lo=inportb(0x40);
	byte hi=inportb(0x40);
	asm volatile ("sti");

	long ticks = (0x10000 - (hi*256+lo));

	return (etsc-stsc)*1193180 / ticks;
}

void DelayS (int s)
{
	DelayMs(s * 3000);
}

void DelayMs (int ms)
{
	cycles_t t1 = currentcycles();
	for(int i=0;i<10;i++);
	cycles_t t2 = currentcycles();

	cycles_t t = (t2 - t1) * ms;
	cycles_t i;	

	for (i=0;i<t;i++);	
}
