/*
 * MudStorm OS
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <system.h>
#include <delay.h>
#include <stdio.h>

void Init(unsigned int magic)
{
	if (magic != 0x2BADB002) 
	{
		printf("Errore, riavviare la macchina");
	}
	else
	{
		printf("Inizializzo le GDT...");
		DelayS(2);
		gdt_install();
		pcolor(GREEN);
		printf("\t\t\t[OK]");
		pcolor(WHITE);
		printf("\nInizializzo gli IDT...");
		DelayS(2);
   		idt_install();
		pcolor(GREEN);
		printf("\t\t\t[OK]");
		pcolor(WHITE);
		printf("\nInizializzo le ISR...");
		DelayS(2);
   		isrs_install();
		pcolor(GREEN);
		printf("\t\t\t[OK]");
		pcolor(WHITE);
		printf("\nInizializzo gli IRQ...");
		DelayS(2);
   		irq_install();
		pcolor(GREEN);
		printf("\t\t\t[OK]");
		pcolor(WHITE);
		printf("\nInizializzo il Timer...");
		DelayS(2);
		timer_install();
		pcolor(GREEN);
		printf("\t\t\t[OK]");
		pcolor(WHITE);
		printf("\nInizializzo la Tastiera...");
		keyboard_install();
		pcolor(GREEN);
		printf("\t\t[OK]");
		pcolor(WHITE);
		printf("\nAbilito gli Interrupt...");
   		__asm__ __volatile__ ("sti");
		pcolor(GREEN);
		printf("\t\t[OK]");
		pcolor(WHITE);
	}
}
