/*
 * MudStorm OS
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 *  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <system.h>
#include <stdio.h>
#include <time.h>
#include <delay.h>
#include <version.h>

int DEBUG = 0;
#define USR "Guest"

void help()
{
	if (DEBUG) printf("\nScrivo i comandi possibili a video\n");
	for (int i=0;i<NUM;i++)
	{
	printf("\n %s - %s", shellcmd[i].cmdname, shellcmd[i].cmddesc);
	}
	printf("\n");
}

void clear()
{
	if (DEBUG) printf("\nPulisco lo schermo");
	cls();
	if (DEBUG) printf("\nStampo a video il logo\n");
	logo();
}

void uname()
{
	if (DEBUG) printf("\nStampo a video le informazioni dell'OS\n");
	pcolor(BLUE);
	printf("\n%s%s, %s: %s - %s: %s\n%s: %s\n", "MudStormOS", REVISION, "Kernel", KERNEL, "Shell", SHELL, "Autore", AUTHOR);
	pcolor(WHITE);
}

void date()
{
	if (DEBUG) printf("\nLeggo le informazioni dall'RTC");
	read_rtc();
	if (DEBUG) printf("\nScrivo le informazioni ricevute dall'RTC\n");
	printf("\n %d:%d:%d - %d/%d/%d\n", hour, minute, second, day, month, year);
}

void echo()
{
	if (DEBUG) printf("\nTi chiedo di scrivere qualcosa\n");
	string wrote = "";
	printf("Scrivi: ");
	scanf("%s", wrote);
	printf("\n%s\n", wrote);
}

void cpu()
{
	if (DEBUG) printf("\nScrivo a video la velocità (attuale) della CPU\n");
	int speed = cpu_speed();
	printf("\n%d (MHz)\n", speed);
}

void beepp()
{
	if (DEBUG) printf("\nFaccio suonare il buzzer\n");
	beep();
}

void debug()
{
	if (DEBUG)
	{
		DEBUG = 0;
		printf("\nDebug disabilitato\n");
	}
	else
	{
		DEBUG = 1;
		printf("\nDebug abilitato\n");
	}
}

void logos()
{
	if (DEBUG) printf("\nStampo a video il logo");
	logo();
}

void exit()
{
	if (DEBUG) printf("\nPulisco lo schermo e inizializzo la Shell");
	cls();
	initShell();
}

void reb()
{
	if (DEBUG) printf("\nRiavvio la macchina");
	reboot();
}

void shut()
{
	if (DEBUG) printf("\nArresto la macchina");
	shutdown();
}

struct cmd shellcmd[NUM] = {
{ "help", help, "Mostra i comandi" },
{ "clear", clear, "Pulisce lo schermo" },
{ "uname", uname, "Mostra le informazioni sull'OS" },
{ "date", date, "Mostra la data" },
/* { "cpu", cpu, "Mostra la velocita' attuale della CPU" }, */ //Non funziona come dovrebbe!
{ "echo", echo, "Scrivi a schermo" },
{ "beep", beepp, "Suona col buzzer" },
{ "debug", debug, "Controlla cosa fa la shell" },
{ "logo", logos, "Stampa a schermo il logo" },
{ "exit", exit, "Esce dalla shell" },
{ "reboot", reb, "Riavvia la macchina" },
{ "shutdown", shut, "Arresta la macchina" },
};

int find(string cmd)
{
	for(int i=0;i<NUM;i++)
	{
		if(!strcmp(shellcmd[i].cmdname, cmd)) return i;
	}
	return -1;
}

void runShell()
{
	string command = NULL;

	cls();
	logo();
	pcolor(BAK_WHITE);
	printf("			<help> per conoscere i comandi\n");
	pcolor(WHITE);
	
	while(1)
	{
		printf("\n%s:~$ ", USR);
		scanf("%s", command);
		int i = find(command);
		if (i >= 0)
		{
			void (*commandJump)(void);
			commandJump = shellcmd[i].v_func;
			commandJump();
		}
	}
}
